"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Codec = void 0;
class Codec {
  schema;
  _;
  static new = schema => new Codec(schema);
  decode(source) {
    this._.$ = source;
    for (let ix = 0, len = this._.to.length; ix < len; ix++) {
      const f = this._.to[ix];
      this._.$ = f(this._.$);
    }
    return this._.$;
  }
  encode(target) {
    this._.$ = target;
    for (let ix = this._.from.length; ix-- !== 0;) {
      const f = this._.from[ix];
      this._.$ = f(this._.$);
    }
    return this._.$;
  }
  extend(premap) {
    return {
      unextend: mapBack => new Codec(this.schema, {
        to: [premap, ...this._.to],
        from: [mapBack, ...this._.from],
        $: void 0
      })
    };
  }
  pipe(map) {
    return {
      unpipe: unmap => new Codec(this.schema, {
        to: [...this._.to, map],
        from: [...this._.from, unmap],
        $: void 0
      })
    };
  }
  constructor(schema, _ = {
    from: [],
    to: [],
    $: void 0
  }) {
    this.schema = schema;
    this._ = _;
  }
}
exports.Codec = Codec;
//# sourceMappingURL=codec.js.map