import { t } from '@traversable/schema-core';
export interface Pipe<S, T, A, B> {
    unpipe(mapBack: (b: B) => T): Codec<S, B, A>;
}
export interface Extend<S, T, A, B> {
    unextend(mapBack: (s: S) => B): Codec<B, T, A>;
}
export declare class Codec<S, T, A> {
    schema: A;
    private _;
    static new: <S extends t.Schema<t.LowerBound>>(schema: S) => Codec<S['_type'], S['_type'], S>;
    decode(source: S): T;
    encode(target: T): S;
    extend<B>(premap: (b: B) => S): Extend<S, T, A, B>;
    pipe<B>(map: (t: T) => B): Pipe<S, T, A, B>;
    private constructor();
}
//# sourceMappingURL=codec.d.ts.map